/*      .  WWW.MDOGA.RU
    */
// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny2313


#pragma used+
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   // 16 bit access
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// for compatibility with the interrupt vector names from Atmel's datasheet


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


unsigned char sec=0x00;      // 
unsigned char ed_min=0x00;   //  
unsigned char des_min=0x00;  //  
unsigned char ed_chas=0x00;  //  
unsigned char des_chas=0x00; //  
unsigned char znak [10] = {0b11111100, 0b01100000, 0b11011010, 0b11110010, 0b01100110, 0b10110110, 0b10111110, 0b11100000, 0b11111110, 0b11110110}; //     

//------------------------------    --------------------------------- 

unsigned char x=0; //     "tablo"
unsigned char y=0; //     "tablo"

void tablo(void)
{for (x=0; x<8; x++)
{PORTB.0=y&1;
PORTB.2=0xFF;PORTB.2=0x00;
y=y>>1;}}
  
//------------------------------    ----------------------------------
interrupt [5] void timer1_compa_isr(void)
{
//sec++;
ed_min++;}

//---------------------------------- -------------------------------------
void main(void)
{
PORTB=0x00; DDRB=0xff;  //   B
PORTD=0x00; DDRD=0xff;  //   D

// -------  1.     A=31250,  .----------------
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x3D;
OCR1AL=0x08;
OCR1BH=0x00;
OCR1BL=0x00;

TIMSK=0x40;
ACSR=0x80;
#asm("sei")

//---------------------------- , , -----------------------------------
while (1)
{
//if (sec==10) {sec=0; ed_min++;}
if (ed_min==10) {ed_min=0; des_min++;}
if (des_min==6) {des_min=0; ed_chas++;}
if (ed_chas==10) {ed_chas=0; des_chas++;}
if (des_chas==2) {if (ed_chas==4) {des_chas=0; ed_chas=0;}}

//---  "y"       .    - .,  ,  , . ---
y=znak [ed_min];  tablo();
y=znak [des_min]; tablo();
y=znak [ed_chas]; tablo();
y=znak [des_chas];tablo();

PORTB.1=0xFF;PORTB.1=0x00; //      
}} 

